--PlayerCCRoot[name]={LEVEL_OF_DR, TIME_OF_DR, STATUS_OF_DR, LAST_SPELL_NAME}
--LEVEL_OF_DR starts at 0 for no on dr, and goes to 3 for full dr
--TIME_OF_DR is the last applied time that the dr changed.
--STATUS_OF_DR is true for the cc being still on,f alse if it is not on
--LAST_SPELL_NAME
PlayerCCRoot={}
PlayerCCStun={}
PlayerCCHorror={}
PlayerCCFear={}
PlayerCCSilence={}

local DRColors={}
DRColors[0]={0, 0, 0} --no cc, blank
DRColors[1]={0, 1, 0} --wearing off first level, green
DRColors[2]={1, 1, 0} --wearing off 2nd level, yellow
DRColors[3]={1, 0, 0} --wearing off immune, red
DRColors[4]={0, 1, 1} --CC'd for first level, blue
DRColors[5]={1, 1, 1} --CC'd for 2nd level, white
DRColors[6]={1, 0, 1} --CC'd for immunity, pink

function AddCC(name, spell, spellid)
	local kind=NamesOfCCSpells[spell]
	--print("Adding", kind, "CC to", name, "of spell name", spell)
	if _G["PlayerCC" .. kind][name] then 
		if GetTime() - _G["PlayerCC" .. kind][name][2]<18 then -- DR has not worn off
			_G["PlayerCC" .. kind][name]={math.min(3, _G["PlayerCC" .. kind][name][1]+1), GetTime(), 1, spellid}
		else
			_G["PlayerCC" .. kind][name]={1, GetTime(), 1, spellid}
		end
	else
		_G["PlayerCC" .. kind][name]={1, GetTime(), 1, spellid}
	end
	--print(_G["PlayerCC" .. kind][name][1], _G["PlayerCC" .. kind][name][2], _G["PlayerCC" .. kind][name][3], _G["PlayerCC" .. kind][name][4])
end

function RemoveCC(name, spell, spellid)
	local kind=NamesOfCCSpells[spell]
	--print("Removing", kind, "CC from", name, "of spell name", spell)
	if _G["PlayerCC" .. kind][name] then 
		_G["PlayerCC" .. kind][name]={_G["PlayerCC" .. kind][name][1], GetTime(), 0, spellid}
	else
		_G["PlayerCC" .. kind][name]={1, GetTime(), 0, spellid}
	end
	--print(_G["PlayerCC" .. kind][name][1], _G["PlayerCC" .. kind][name][2], _G["PlayerCC" .. kind][name][3], _G["PlayerCC" .. kind][name][4])
end

local function GetData(name, category)
	if _G["PlayerCC" .. category][name] then
		--print(name, category, _G["PlayerCC" .. category][name][1], _G["PlayerCC" .. category][name][2], _G["PlayerCC" .. category][name][3], _G["PlayerCC" .. category][name][4])
		return _G["PlayerCC" .. category][name]
	else
		--print(name, category, 0, 0, 0, nil)
		return {0, 0, 0, nil}
	end
end

local function SetDRFrame(name, category, time, color, spellid, offset)
	--print(name, category, time, color, spellid, offset)
	if time>0 and DRWork then
		time=string.format("%.0f", time)
		_G["PlayerFrame" .. name .. category]:Show()
		_G["PlayerFrame" .. name .. category]:SetPoint("RIGHT",_G["PlayerFrame" .. name],"LEFT", -offset*CurrentFrameHeight, 0)
		--_G["PlayerFrame" .. name .. category]:SetBackdrop({bgFile = GetSpellTexture("Kidney Shot"), tile = false})
		--_G["PlayerFrame" .. name .. category]:SetTexture(spellid)
		_G["PlayerFrame" .. name .. category].number:SetText(time)
		_G["PlayerFrame" .. name .. category].number:SetTextColor(DRColors[color][1], DRColors[color][2], DRColors[color][3])
		return 1
	else
		_G["PlayerFrame" .. name .. category]:Hide()
		return 0
	end
end

local function DrawDRForPlayer(name)
	local root, stun, horror, fear, silence
	local offset=0
	if TargetCountEnable and PlayerIsTargeted[name] then offset=1 end
	root=GetData(name, "Root")
	stun=GetData(name, "Stun")
	horror=GetData(name, "Horror")
	fear=GetData(name, "Fear")
	silence=GetData(name, "Silence")
	
	offset=offset+SetDRFrame(name, "Root", math.max((18-(GetTime()-root[2])), 18*root[3]), 3*root[3]+root[1], root[4], offset)
	offset=offset+SetDRFrame(name, "Stun", math.max((18-(GetTime()-stun[2])), 18*stun[3]), 3*stun[3]+stun[1], stun[4], offset)
	offset=offset+SetDRFrame(name, "Horror", math.max((18-(GetTime()-horror[2])), 18*horror[3]), 3*horror[3]+horror[1], horror[4], offset)
	offset=offset+SetDRFrame(name, "Fear", math.max((18-(GetTime()-fear[2])), 18*fear[3]), 3*fear[3]+fear[1], fear[4], offset)
	offset=offset+SetDRFrame(name, "Silence", math.max((18-(GetTime()-silence[2])), 18*silence[3]), 3*silence[3]+silence[1], silence[4], offset)
end

function WPVPFUpdateDR()
	local frame=mainframe
	if frame:GetNumChildren()>MainFrameChildren then --There are player frames in existance
		frame=select(MainFrameChildren+1, frame:GetChildren()) --frame is now the first player frame
		repeat 
			health=select(1, frame:GetChildren())
			local name=health.name:GetText()
			DrawDRForPlayer(name)
			if select(ChildrenFrames+1, frame:GetChildren()) then 
				frame=select(ChildrenFrames+1, frame:GetChildren()) 
			else
				frame=nil
			end
		until not frame
	end
end




NamesOfCCSpells={}
NamesOfCCSpells["Chains of Ice"]="Root"
NamesOfCCSpells["Entangling Roots"]="Root"
NamesOfCCSpells["Mass Entanglement"]="Root"
NamesOfCCSpells["Narrow Escape"]="Root"
NamesOfCCSpells["Entrapment"]="Root"
NamesOfCCSpells["Freeze (Water Elemental)"]="Root"
NamesOfCCSpells["Frost Nova"]="Root"
NamesOfCCSpells["Ice Ward"]="Root"
NamesOfCCSpells["Disable"]="Root"
NamesOfCCSpells["Spinning Fire Blossom"]="Root"
NamesOfCCSpells["Glyph of Mind Blast"]="Root"
NamesOfCCSpells["Void Tendrils"]="Root"
NamesOfCCSpells["Frozen Power"]="Root"
NamesOfCCSpells["Earthgrab Totem"]="Root"
NamesOfCCSpells["Staggering Shout"]="Root"

NamesOfCCSpells["Asphyxiate"]="Stun"
NamesOfCCSpells["Gnaw"]="Stun"
NamesOfCCSpells["Monstrous Blow"]="Stun"
NamesOfCCSpells["Remorseless Winter"]="Stun"
NamesOfCCSpells["Maim"]="Stun"
NamesOfCCSpells["Mighty Bash"]="Stun"
NamesOfCCSpells["Rake"]="Stun"
NamesOfCCSpells["Binding Shot"]="Stun"
NamesOfCCSpells["Intimidation"]="Stun"
NamesOfCCSpells["Deep Freeze"]="Stun"
NamesOfCCSpells["Charging Ox Wave"]="Stun"
NamesOfCCSpells["Fists of Fury"]="Stun"
NamesOfCCSpells["Leg Sweep"]="Stun"
NamesOfCCSpells["Hammer of Justice"]="Stun"
NamesOfCCSpells["Holy Wrath"]="Stun"
NamesOfCCSpells["Fist of Justice"]="Stun"
NamesOfCCSpells["Cheap Shot"]="Stun"
NamesOfCCSpells["Kidney Shot"]="Stun"
NamesOfCCSpells["Pulverize"]="Stun"
NamesOfCCSpells["Static Charge"]="Stun"
NamesOfCCSpells["Axe Toss"]="Stun"
NamesOfCCSpells["Shadowfury"]="Stun"
NamesOfCCSpells["Summon Infernal"]="Stun"
NamesOfCCSpells["War Stomp"]="Stun"
NamesOfCCSpells["Shockwave"]="Stun"

NamesOfCCSpells["Incapacitating Roar"]="Horror"
NamesOfCCSpells["Freezing Trap"]="Horror"
NamesOfCCSpells["Wyvern Sting"]="Horror"
NamesOfCCSpells["Polymorph"]="Horror"
NamesOfCCSpells["Ring of Frost"]="Horror"
NamesOfCCSpells["Dragon's Breath"]="Horror"
NamesOfCCSpells["Paralysis"]="Horror"
NamesOfCCSpells["Ring of Peace"]="Horror"
NamesOfCCSpells["Breath of Fire"]="Horror"
NamesOfCCSpells["Repentance"]="Horror"
NamesOfCCSpells["Holy Word: Chastise"]="Horror"
NamesOfCCSpells["Psychic Horror"]="Horror"
NamesOfCCSpells["Mind Control"]="Horror"
NamesOfCCSpells["Gouge"]="Horror"
NamesOfCCSpells["Sap"]="Horror"
NamesOfCCSpells["Hex"]="Horror"
NamesOfCCSpells["Blood Horror"]="Horror"
NamesOfCCSpells["Mortal Coil"]="Horror"
NamesOfCCSpells["Quaking Palm"]="Horror"
NamesOfCCSpells["Ice Nova"]="Horror"

NamesOfCCSpells["Cyclone"]="Fear"
NamesOfCCSpells["Turn Evil"]="Fear"
NamesOfCCSpells["Psychic Scream"]="Fear"
NamesOfCCSpells["Blind"]="Fear"
NamesOfCCSpells["Fear"]="Fear"
NamesOfCCSpells["Howl of Terror"]="Fear"
NamesOfCCSpells["Mesmerize"]="Fear"
NamesOfCCSpells["Seduction"]="Fear"
NamesOfCCSpells["Intimidating Shout"]="Fear"

NamesOfCCSpells["Strangulate"]="Silence"
NamesOfCCSpells["Glyph of Fae Silence"]="Silence"
NamesOfCCSpells["Frostjaw"]="Silence"
NamesOfCCSpells["Avenger's Shield"]="Silence"
NamesOfCCSpells["Silence"]="Silence"
NamesOfCCSpells["Garrote"]="Silence"
NamesOfCCSpells["Spell Lock"]="Silence"
NamesOfCCSpells["Optical Blast"]="Silence"
NamesOfCCSpells["Arcane Torrent"]="Silence"
